/*
 * Copyright (c) 2022 Jiri Svoboda
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 * - The name of the author may not be used to endorse or promote products
 *   derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/** @addtogroup display
 * @{
 */
/**
 * @file Display server WM client
 */

#ifndef WMCLIENT_H
#define WMCLIENT_H

#include <errno.h>
#include <wndmgt.h>
#include "types/display/display.h"
#include "types/display/wmclient.h"

extern errno_t ds_wmclient_create(ds_display_t *, ds_wmclient_cb_t *, void *,
    ds_wmclient_t **);
extern void ds_wmclient_destroy(ds_wmclient_t *);
extern errno_t ds_wmclient_get_event(ds_wmclient_t *,  wndmgt_ev_t *);
extern errno_t ds_wmclient_post_wnd_added_event(ds_wmclient_t *, sysarg_t);
extern errno_t ds_wmclient_post_wnd_removed_event(ds_wmclient_t *, sysarg_t);
extern errno_t ds_wmclient_post_wnd_changed_event(ds_wmclient_t *, sysarg_t);
extern void ds_wmclient_purge_events(ds_wmclient_t *);

#endif

/** @}
 */
